@echo off
rem --------------------------------------------------------------------------------
rem (C) COPYRIGHT International Business Machines Corp. 2000-2008
rem All Rights Reserved
rem
rem US Government Users Restricted Rights - Use, duplication or
rem disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
rem
rem NAME: setup.bat
rem
rem FUNCTION: Server side setup of Parcel Demo. 
rem --------------------------------------------------------------------------------

title Parcel Demo Server Side Setup

echo Welcome to Parcel Demo, by DB2 Everyplace @ IBM !
echo.
Set db2e_path=C:\Progra~1\IBM\DB2Eve~1
:start
echo ********************************** Main Menu *********************************
echo ** (0) Check and input DB2E install path (pre-requisite)                    **
echo ** (1) Install all components of server side                                **
echo ** (2) Uninstall all components of server side                              **
echo ** (3) Install server side web pages only                                   **
echo ** (4) Uninstall server side web pages                                      **
echo ** (5) Install the database and sync configurations only                    **
echo ** (6) Uninstall the database and sync configurations                       **
echo ** (7) Reset the source database                                            **
echo ** (8) Exit                                                                 **


:begin
set  /p choise=Make a selection:

if "%choise%"=="0"  GOTO step0
if "%choise%"=="1"  GOTO step1
if "%choise%"=="2"  GOTO step2
if "%choise%"=="3"  GOTO step3
if "%choise%"=="4"  GOTO step4
if "%choise%"=="5"  GOTO step5
if "%choise%"=="6"  GOTO step6
if "%choise%"=="7"  GOTO step7
if "%choise%"=="8"  GOTO step8

echo.
GOTO start

rem ________________________________________________________________

:step0
:db2echeck
Echo ...
Echo Checking DB2e...
if not exist %db2e_path%\Server\bin\dsysync.bat (
ECHO DB2 EveryPlace not found in %db2e_path%. 
ECHO If you didn't install it in the default path , you can point it out.
ECHO Would you like to specify the DB2E install path manually?  [Y/N]
) else (
ECHO ...
ECHO DB2E install path found! You can start setup. & ECHO db2e check passed. >>setup.log & goto start
)

set /p choice=
goto db2e%choice%

:db2ey
echo ...
echo Please input DB2 EveryPlace install path:
echo Notice: path should be in the short format. 
ECHO For example, "C:\Program Files\IBM\DB2Everyplace91" should be input as "C:\Progra~1\IBM\DB2Eve~1"
set /p db2e_path=
goto db2echeck
:db2en
ECHO DB2 Everyplace install path is not configured correctly. You may not be able to install the application.
ECHO DB2 EveryPlace not found. >>setup.log 
goto start

:step1
ECHO Initialization installation environment...
ECHO Cleaning environment...
call "%db2e_path%\Server\bin\dsyadminxml.bat" -d parcel_clean.xml >>setup.log
if errorlevel 1 ECHO An error occured when calling %db2e_path%\Server\bin\dsyadminxml.bat. >>setup.log  & goto sfail
ECHO Setting up DataBase...

DB2CMD db2 -tvf setup.sql >>setup.log
PAUSE
ECHO Setting up Subscription...
ECHO Starting up Sync Server...
call "%db2e_path%\Server\bin\dsysync.bat"  
if errorlevel 1 ECHO Sync Server start-up failed. Make sure the Sync Server install Dir is %db2e_path%\Server\bin\dsysync.bat >>setup.log & goto sfail
ECHO Importing XML Configuration File...
call "%db2e_path%\Server\bin\dsyadminxml.bat" -d parcel.xml >>setup.log
if errorlevel 1 ECHO An error occured when calling %db2e_path%\Server\bin\dsyadminxml.bat. >>setup.log  & goto sfail
ECHO Done!
ECHO Replicating DataBase...
call "%db2e_path%\Server\bin\dsyreplicate.bat" parcelmd 
if errorlevel 1 ECHO An error occured when calling %db2e_path%\Server\bin\dsyreplicate.bat. >>setup.log  & goto sfail
ECHO Done!
ECHO Install Web Application:db2e_mparcel.ear...
call "%db2e_path%\WAS\bin\wsadmin.bat" -f install_ear.jacl
ECHO Setup web app .ear file... >>setup.log
if errorlevel 1 ECHO Calling %db2e_path%\WAS\bin\wsadmin.bat failed. >>setup.log & goto sfail
ECHO Server Setting up complete! 
ECHO Server Setting up complete!>>setup.log
ECHO All installation completed in server side!
ECHO Visit http://localhost:8080/mparcel/ to view the web pages of the server side.
ECHO ...
rem C:\Progra~1\Intern~1\iexplore.exe "http://localhost:8080/mparcel"
goto send
:sfail
Echo Setting up failed. Check log file for detail. 
Echo Setting up failed. >>setup.log
:send

goto start

:step2
rem Uninstall all components
Echo Uninstall server side components...
rem Uninstall server side web pages
ECHO Uninstall server side web pages...
call "%db2e_path%\WAS\bin\wsadmin.bat" -f uninstall_ear.jacl
ECHO uninstall web app .ear file... >>setup.log
if errorlevel 1 ECHO Calling %db2e_path%\WAS\bin\wsadmin.bat failed. >>setup.log & goto s4fail

rem Uninstall the database and sync configurations 
Echo Uninstall sync configurations ...
Echo...
call "%db2e_path%\Server\bin\dsyadminxml.bat" -d parcel_clean.xml >>setup.log
if errorlevel 1 ECHO An error occured when calling %db2e_path%\Server\bin\dsyadminxml.bat. >>setup.log 
ECHO Uninstall the database ...
DB2CMD db2 -tvf drop.sql >>setup.log
Echo .
Echo Uninstall completed.
goto start

:step3
rem Install server side web pages only
ECHO Install Web Application:db2e_mparcel.ear...
call "%db2e_path%\WAS\bin\wsadmin.bat" -f install_ear.jacl
ECHO Setup web app .ear file... >>setup.log
if errorlevel 1 ECHO Calling %db2e_path%\WAS\bin\wsadmin.bat failed. >>setup.log & goto sfail
goto start

:step4
rem Uninstall server side web pages
ECHO Uninstall server side web pages...
call "%db2e_path%\WAS\bin\wsadmin.bat" -f uninstall_ear.jacl
ECHO uninstall web app .ear file... >>setup.log
if errorlevel 1 ECHO Calling %db2e_path%\WAS\bin\wsadmin.bat failed. >>setup.log & goto s4fail
goto start
:s4fail
Echo uninstall web pages failed..
goto start

:step5
rem Install the database and sync configurations 
ECHO Cleaning environment...
call "%db2e_path%\Server\bin\dsyadminxml.bat" -d parcel_clean.xml >>setup.log
if errorlevel 1 ECHO An error occured when calling %db2e_path%\Server\bin\dsyadminxml.bat. >>setup.log  & goto sfail
ECHO Setting up DataBase...

DB2CMD db2 -tvf setup.sql >>setup.log
PAUSE
ECHO Setting up Subscription...
ECHO Starting up Sync Server...
call "%db2e_path%\Server\bin\dsysync.bat"  
if errorlevel 1 ECHO Sync Server start-up failed. Make sure the Sync Server install Dir is %db2e_path%\Server\bin\dsysync.bat >>setup.log & goto sfail
ECHO Importing XML Configuration File...
call "%db2e_path%\Server\bin\dsyadminxml.bat" -d parcel.xml >>setup.log
if errorlevel 1 ECHO An error occured when calling %db2e_path%\Server\bin\dsyadminxml.bat. >>setup.log  & goto sfail
ECHO Done!
ECHO Replicating DataBase...
call "%db2e_path%\Server\bin\dsyreplicate.bat" parcelmd 
if errorlevel 1 ECHO An error occured when calling %db2e_path%\Server\bin\dsyreplicate.bat. >>setup.log  & goto sfail
ECHO Done!
goto start

:step6
rem Uninstall the database and sync configurations 
Echo Uninstall sync configurations ...
Echo...
call "%db2e_path%\Server\bin\dsyadminxml.bat" -d parcel_clean.xml >>setup.log
if errorlevel 1 ECHO An error occured when calling %db2e_path%\Server\bin\dsyadminxml.bat. >>setup.log 
ECHO Uninstall the database ...
DB2CMD db2 -tvf drop.sql >>setup.log
Echo .
goto start

:step7
rem Reset the source database
ECHO Resetting DataBase...
ECHO Resetting DataBase... >>setup.log
DB2CMD db2 -tvf reset.sql >>setup.log
ECHO .
goto start




:step8
exit 0


